/* Created on 27-set-2005 */
package jtransfer.gui;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import jtransfer.JTransfer;
import jtransfer.Osservatore;
import jtransfer.Service;

public class JFileTransfer extends JFrame implements Osservatore {

	public static JFileTransfer instance;
	
	private JPanel jContentPane = null;

	private JMenuBar jJMenuBar = null;

	private JMenu fileMenu = null;

	private JMenuItem exitMenuItem = null;

	private JPanel jPanel = null;

	private JLabel jLabel = null;

	private JTextField jTextField = null;

	private JPanel jPanel1 = null;

	private JRadioButton jRadioButton = null;

	private JRadioButton jRadioButton1 = null;

	private JButton jButton = null;

	private JPanel jPanel2 = null;

	private JLabel jLabel1 = null;

	private JTextField jTextField1 = null;

	private JLabel jLabel2 = null;

	private JTextField jTextField2 = null;

	private JPanel jPanel3 = null;

	private JLabel jLabel3 = null;

	private JLabel jLabel4 = null;

	private JProgressBar jProgressBar = null;

	private JPanel jPanel4 = null;

	private JLabel jLabel5 = null;

	private JTransfer jt;

	private JLabel jLabel6 = null;

	private JButton jButton1 = null;
	
	private JFileChooser jFileChooserScegli = null;
	/**
	 * This is the default constructor
	 */
	public JFileTransfer() {
		super();
		initialize();
		this.jt = new JTransfer();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setResizable(false);
		this.setPreferredSize(new java.awt.Dimension(400,235));
		this.setMaximumSize(new java.awt.Dimension(575,300));
		this.setFont(new java.awt.Font("Bitstream Vera Sans", java.awt.Font.PLAIN, 12));
		this.setJMenuBar(getJJMenuBar());
		this.setSize(414, 256);
		this.setContentPane(getJContentPane());
		this.setTitle("JFileTransfer");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridLayout gridLayout31 = new GridLayout();
			gridLayout31.setRows(6);
			GridLayout gridLayout2 = new GridLayout();
			gridLayout2.setRows(6);
			gridLayout2.setColumns(1);
			GridLayout gridLayout11 = new GridLayout();
			gridLayout11.setRows(5);
			gridLayout11.setColumns(1);
			GridLayout gridLayout = new GridLayout();
			gridLayout.setRows(5);
			gridLayout.setColumns(1);
			jContentPane = new JPanel();
			jContentPane.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			jContentPane.setPreferredSize(new java.awt.Dimension(150,300));
			jContentPane.setLayout(gridLayout31);
			jContentPane.add(getJPanel(), null);
			jContentPane.add(getJPanel2(), null);
			jContentPane.add(getJPanel1(), null);
			jContentPane.add(getJPanel3(), null);
			jContentPane.add(getJProgressBar(), null);
			jContentPane.add(getJPanel4(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jJMenuBar	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */
	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
			jJMenuBar.add(getFileMenu());
			// jJMenuBar.add(getEditMenu());
			// jJMenuBar.add(getHelpMenu());
		}
		return jJMenuBar;
	}

	/**
	 * This method initializes jMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getFileMenu() {
		if (fileMenu == null) {
			fileMenu = new JMenu();
			fileMenu.setText("File");
			// fileMenu.add(getSaveMenuItem());
			fileMenu.add(getExitMenuItem());
		}
		return fileMenu;
	}

	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getExitMenuItem() {
		if (exitMenuItem == null) {
			exitMenuItem = new JMenuItem();
			exitMenuItem.setText("Exit");
			exitMenuItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					JFileTransfer.instance.closeAll();
					System.exit(0);
				}
			});
		}
		return exitMenuItem;
	}
	
	protected void closeAll() {
		this.jt.stop();
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setAlignment(java.awt.FlowLayout.LEFT);
			jLabel = new JLabel();
			jLabel.setText("File to send");
			jPanel = new JPanel();
			jPanel.setPreferredSize(new java.awt.Dimension(400,29));
			jPanel.setLayout(flowLayout);
			jPanel.add(jLabel, null);
			jPanel.add(getJTextField(), null);
			jPanel.add(getJButton1(), null);
		}
		return jPanel;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setColumns(24);
		}
		return jTextField;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.setPreferredSize(new java.awt.Dimension(400,35));
			jPanel1.setLayout(new FlowLayout());
			jPanel1.add(getJRadioButton(), null);
			jPanel1.add(getJRadioButton1(), null);
			jPanel1.add(getJButton(), null);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jRadioButton	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton() {
		if (jRadioButton == null) {
			jRadioButton = new JRadioButton();
			jRadioButton.setText("Send file");
			jRadioButton.setSelected(true);
			jRadioButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					((JFileTransfer) (((Component)e.getSource()).getParent().getParent().getParent().getParent().getParent())).setSending(); 
				}
			});
		}
		return jRadioButton;
	}

	protected void setSending() {
		this.jLabel.setText("File to send");
		this.jTextField.setText("");
		this.jTextField1.setText("Not needed");
		this.jTextField1.setEnabled(false);
		this.jRadioButton1.setSelected(false);
		this.jRadioButton.setSelected(true);
		this.jTextField.setColumns(24);
	}

	/**
	 * This method initializes jRadioButton1	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton1() {
		if (jRadioButton1 == null) {
			jRadioButton1 = new JRadioButton();
			jRadioButton1.setText("Receive file");
			jRadioButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					((JFileTransfer) (((Component)e.getSource()).getParent().getParent().getParent().getParent().getParent())).setReceiving();
					 
				}
			});
		}
		return jRadioButton1;
	}

	protected void setReceiving() {
		this.jLabel.setText("Receive to dir");
		this.jTextField.setText("");
		this.jTextField1.setText("");
		this.jTextField1.setEnabled(true);
		this.jTextField.setColumns(23);
		this.jRadioButton1.setSelected(true);
		this.jRadioButton.setSelected(false);
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("Perform");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					((JFileTransfer) (((Component)e.getSource()).getParent().getParent().getParent().getParent().getParent())).performIt(); // 
				}
			});
		}
		return jButton;
	}

	protected void performIt() {
		if (this.jButton.getText().equals("Perform")) {
			this.jLabel3.setText("Length: ");
			this.jLabel4.setText("File: ");
			this.jProgressBar.setValue(0);
			// invia dunque un file
			if (this.jRadioButton.isSelected()) {
				
				this.jt.sendFile(this.jTextField.getText(),Integer.parseInt(this.jTextField2.getText()));
				
			} else {
				
				this.jt.receiveFile(this.jTextField.getText(),this.jTextField1.getText(),Integer.parseInt(this.jTextField2.getText()));
			}
			this.jt.addObserver(this);
			this.jt.startAction();
		} else {
			this.jt.stop();
		}
		
	}

	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			FlowLayout flowLayout1 = new FlowLayout();
			flowLayout1.setAlignment(java.awt.FlowLayout.LEFT);
			jLabel2 = new JLabel();
			jLabel2.setText("Port");
			jLabel1 = new JLabel();
			jLabel1.setText("Host");
			jPanel2 = new JPanel();
			jPanel2.setLayout(flowLayout1);
			jPanel2.setPreferredSize(new java.awt.Dimension(400,30));
			jPanel2.add(jLabel1, null);
			jPanel2.add(getJTextField1(), null);
			jPanel2.add(jLabel2, null);
			jPanel2.add(getJTextField2(), null);
		}
		return jPanel2;
	}

	/**
	 * This method initializes jTextField1	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField1() {
		if (jTextField1 == null) {
			jTextField1 = new JTextField();
			jTextField1.setColumns(16);
			jTextField1.setText("Not needed");
			jTextField1.setEnabled(false);
		}
		return jTextField1;
	}

	/**
	 * This method initializes jTextField2	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField2() {
		if (jTextField2 == null) {
			jTextField2 = new JTextField();
			jTextField2.setColumns(5);
			jTextField2.setText("43000");
		}
		return jTextField2;
	}

	/**
	 * This method initializes jPanel3	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel3() {
		if (jPanel3 == null) {
			jLabel4 = new JLabel();
			jLabel4.setText("File: ");
			jLabel4.setFont(new java.awt.Font("Bitstream Vera Sans", java.awt.Font.PLAIN, 10));
			jLabel4.setPreferredSize(new java.awt.Dimension(350,33));
			GridLayout gridLayout1 = new GridLayout();
			gridLayout1.setRows(2);
			gridLayout1.setVgap(0);
			gridLayout1.setHgap(0);
			gridLayout1.setColumns(1);
			jLabel3 = new JLabel();
			jLabel3.setText("Length:");
			jLabel3.setFont(new java.awt.Font("Bitstream Vera Sans", java.awt.Font.PLAIN, 10));
			jLabel3.setPreferredSize(new java.awt.Dimension(350,33));
			jPanel3 = new JPanel();
			jPanel3.setFont(new java.awt.Font("Bitstream Vera Sans", java.awt.Font.PLAIN, 10));
			jPanel3.setPreferredSize(new java.awt.Dimension(400,60));
			jPanel3.setLayout(gridLayout1);
			jPanel3.add(jLabel4, null);
			jPanel3.add(jLabel3, null);
		}
		return jPanel3;
	}

	/**
	 * This method initializes jProgressBar	
	 * 	
	 * @return javax.swing.JProgressBar	
	 */
	private JProgressBar getJProgressBar() {
		if (jProgressBar == null) {
			jProgressBar = new JProgressBar();
			jProgressBar.setPreferredSize(new java.awt.Dimension(146,15));
			jProgressBar.setString("");
		}
		return jProgressBar;
	}

	/**
	 * This method initializes jPanel4	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel4() {
		if (jPanel4 == null) {
			jLabel6 = new JLabel();
			jLabel6.setText("CRC:");
			jLabel6.setFont(new java.awt.Font("Bitstream Vera Sans", java.awt.Font.PLAIN, 10));
			GridLayout gridLayout5 = new GridLayout();
			gridLayout5.setRows(2);
			GridLayout gridLayout4 = new GridLayout();
			gridLayout4.setRows(1);
			GridLayout gridLayout3 = new GridLayout();
			gridLayout3.setRows(1);
			jLabel5 = new JLabel();
			jLabel5.setFont(new java.awt.Font("Bitstream Vera Sans", java.awt.Font.PLAIN, 10));
			jLabel5.setText("Info:");
			jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
			jLabel5.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			jLabel5.setPreferredSize(new java.awt.Dimension(350,26));
			jPanel4 = new JPanel();
			jPanel4.setPreferredSize(new java.awt.Dimension(400,36));
			jPanel4.setLayout(gridLayout5);
			jPanel4.add(jLabel5, null);
			jPanel4.add(jLabel6, null);
		}
		return jPanel4;
	}

	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setText("...");
			jButton1.setPreferredSize(new java.awt.Dimension(30,17));
			jButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					((JFileTransfer) (((Component)e.getSource()).getParent().getParent().getParent().getParent().getParent())).showFileDialog();
				}
			});
		}
		return jButton1;
	}

	protected void showFileDialog() {
		
		getJFileChooserScegli();
		if (this.jRadioButton.isSelected()) {
			this.jFileChooserScegli.setFileSelectionMode(JFileChooser.FILES_ONLY);
			this.jFileChooserScegli.setDialogTitle("Choose file to send");
		} else {
			this.jFileChooserScegli.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			this.jFileChooserScegli.setDialogTitle("Choose directory to save to");
		}
		this.jFileChooserScegli.show();
		int ritorno = jFileChooserScegli.showOpenDialog(null);
	    if (ritorno == JFileChooser.APPROVE_OPTION) {	
	    	File toOpen = this.jFileChooserScegli.getSelectedFile();
	    	this.jTextField.setText(toOpen.getAbsolutePath());
	    }
	    else {
	    	jFileChooserScegli.setVisible(false);
	    }
	}

	/**
	 * Launches this application
	 */
	public static void main(String[] args) {
		JFileTransfer application = new JFileTransfer();
		instance = application;
		application.pack();
		application.show();
	}

	public void statusCheck(Service c) {
		this.jLabel3.setText("Length: " + c.lengthOfFile() + " bytes");
		this.jLabel4.setText("File: " + c.getNomeFile());
		long length = c.lengthOfFile();
		if (length==0)
			length = 1;
		if (c.isRunning())
			this.jButton.setText("Stop");
		else
			this.jButton.setText("Perform");
		this.jProgressBar.setValue((int)((100 * c.transfered()) / length));
		this.jLabel5.setText("Info: " + c.getInfo());
		this.repaint();
	}

	
	/**
	 * This method initializes jEditorPane	
	 * 	
	 * @return javax.swing.JEditorPane	
	 */    
	private JFileChooser getJFileChooserScegli() {
		if (jFileChooserScegli == null) {
			jFileChooserScegli = new JFileChooser();
			jFileChooserScegli.setPreferredSize(new java.awt.Dimension(400,300));
			jFileChooserScegli.setDialogType(JFileChooser.OPEN_DIALOG);	/*IMPORTANTE!!!!Con questo metodo si scelgono i bottoni del chooser! Tramite le costanti statiche */
			jFileChooserScegli.setDialogTitle("Choose File");
			jFileChooserScegli.setSize(new java.awt.Dimension(400,300));
			jFileChooserScegli.setVisible(false);
		    }
		return jFileChooserScegli;
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"
